with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLOptionElement3_Interface is

   procedure Initialize (This : in out IHTMLOptionElement3_Type) is
   begin
      Set_IID (This, IID_IHTMLOptionElement3);
   end Initialize;

   function Pointer (This : IHTMLOptionElement3_Type)
     return Pointer_To_IHTMLOptionElement3
   is
   begin
      return To_Pointer_To_IHTMLOptionElement3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLOptionElement3_Type;
                     Pointer : in     Pointer_To_IHTMLOptionElement3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_label
     (This : IHTMLOptionElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_label
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_label;

   function Get_label
     (This : IHTMLOptionElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_label
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_label;

end MSHTML.IHTMLOptionElement3_Interface;

